﻿{
	function Roulette(thisObj)
	{

		var ls_Data = new Object();	
		ls_Data.scriptName = "Randomize Roulette";
		ls_Data.scriptTitle = ls_Data.scriptName + " v1.0";
		ls_Data.strButton = "Spin Roulette";
		ls_Data.strHelp = "?";
		ls_Data.strMinAE80 = "This script requires Adobe After Effects CS3 or later.";
		ls_Data.strHelpText = "Koby Goldberg ©2009 \n\n" +
			"UI based on the 'Quote a Day' script by Relu Pene.\n\n" +
			"The script will randomly choose a stoping point for the Roulette Expression, and will start a RAM Preview.\n\n" +
			"Note: This version of the script requires After Effects CS3 or later. It can be used as a dockable panel by placing the script in a ScriptUI Panels subfolder of the Scripts folder, and then choosing this script from the Window menu.\n";

		var separator = "\n" ; 
		var safeToRun = true;
		
		function Roulette_buildUI(thisObj)
		{
			var pal = (thisObj instanceof Panel) ? thisObj : new Window("palette", ls_Data.scriptName, undefined, {resizeable:true});
			
			if (pal != null)
			{
				var res =
				"group { \
					orientation:'column', alignment:['left','top'], \
					main: Group { \
						alignment:['fill','top'], \
						RouletteBtn: Button { text:'" + ls_Data.strButton +"', maximumSize:[100,20], alignment:['right','center'] }, \
						help: Button { text:'" + ls_Data.strHelp +"', maximumSize:[30,20], alignment:['left','center'] }, \
					}, \
				} ";

				pal.grp = pal.add(res);
				pal.layout.layout(true);
				pal.grp.minimumSize = pal.grp.size;
				pal.layout.resize();
				pal.onResizing = pal.onResize = function () {this.layout.resize();}
				
				pal.grp.main.help.onClick = function () {alert(ls_Data.scriptTitle + "\n" + ls_Data.strHelpText, ls_Data.scriptName);}
				pal.grp.main.RouletteBtn.onClick = DoRoulette;
			} 
			return pal;
		}

		function DoRoulette(){
			// create an undo group 
			app.beginUndoGroup("Randomize Roulette");

			var curItem = app.project.activeItem; 
			var T = curItem.frameDuration;

			// check if comp is selected 
			if (curItem == null || !(curItem instanceof CompItem)){ 

				// if no comp selected, display an alert
				alert("Please establish a comp as the active item and run the script again"); 

			} else { 

				now = new Date();
				seed = now.getSeconds();
				var random_number = Math.random(seed);
				curItem.layer("Null 1").effect("myrand")("Slider").setValue(random_number);
				//var cmd = "Preview";
				//alert(app.findMenuCommandId(cmd));
				//{app.executeCommand(app.findMenuCommandId(cmd));} 
				{app.executeCommand(app.findMenuCommandId("RAM Preview"));} 

				// close the undo group
				app.endUndoGroup(); 
			}
		
		}

		if (parseFloat(app.version) < 8.0)
			alert(ls_Data.strMinAE80, ls_Data.scriptName);
		else
		{
			var myPal = Roulette_buildUI(thisObj);
			if (myPal != null)
			{
				if (myPal instanceof Window)
				{
					// Show the palette
					myPal.center();
					myPal.show();
				}
				else
					{myPal.layout.layout(true);}
			}
		}
	}
	Roulette(this);
}